Hex Artifact Content

Artifact 71498ef42a65504ec91ac7f2771f6dd9abf31912:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 74 61 72 67 65 74 6d 6f 64 65  bash..targetmode
0020: 3d 27 69 6e 73 74 61 6c 6c 27 0a 69 66 20 5b 20  ='install'.if [ 
0030: 22 24 31 22 20 3d 3d 20 27 2d 2d 63 70 69 6f 27  "$1" == '--cpio'
0040: 20 5d 3b 20 74 68 65 6e 0a 09 74 61 72 67 65 74   ]; then..target
0050: 6d 6f 64 65 3d 27 61 72 63 68 69 76 65 27 0a 0a  mode='archive'..
0060: 09 73 68 69 66 74 0a 66 69 0a 0a 70 6b 67 3d 22  .shift.fi..pkg="
0070: 24 28 65 63 68 6f 20 22 24 31 22 20 7c 20 73 65  $(echo "$1" | se
0080: 64 20 27 73 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e  d 's@/*$@@;s@^\.
0090: 2a 2f 2a 40 40 27 29 22 0a 0a 69 66 20 5b 20 2d  */*@@')"..if [ -
00a0: 7a 20 22 24 7b 70 6b 67 7d 22 20 5d 3b 20 74 68  z "${pkg}" ]; th
00b0: 65 6e 0a 09 65 63 68 6f 20 22 55 73 61 67 65 3a  en..echo "Usage:
00c0: 20 62 75 69 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20   build [--cpio] 
00d0: 3c 70 61 63 6b 61 67 65 3e 22 20 32 3e 26 31 0a  <package>" 2>&1.
00e0: 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 66 75 6e  ..exit 1.fi..fun
00f0: 63 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e 65 4f  ction determineO
0100: 73 41 72 63 68 28 29 20 7b 0a 09 6f 73 3d 22 24  sArch() {..os="$
0110: 28 75 6e 61 6d 65 20 2d 73 20 7c 20 64 64 20 63  (uname -s | dd c
0120: 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76  onv=lcase 2>/dev
0130: 2f 6e 75 6c 6c 29 22 0a 09 61 72 63 68 3d 22 24  /null)"..arch="$
0140: 28 75 6e 61 6d 65 20 2d 6d 20 7c 20 64 64 20 63  (uname -m | dd c
0150: 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76  onv=lcase 2>/dev
0160: 2f 6e 75 6c 6c 29 22 0a 0a 09 63 61 73 65 20 22  /null)"...case "
0170: 24 7b 61 72 63 68 7d 22 20 69 6e 0a 09 09 69 3f  ${arch}" in...i?
0180: 38 36 29 0a 09 09 09 61 72 63 68 3d 27 69 78 38  86)....arch='ix8
0190: 36 27 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 7d  6'....;;..esac.}
01a0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74 65 72  ..function deter
01b0: 6d 69 6e 65 50 72 65 66 69 78 28 29 20 7b 0a 09  minePrefix() {..
01c0: 64 65 74 65 72 6d 69 6e 65 4f 73 41 72 63 68 0a  determineOsArch.
01d0: 0a 09 70 72 65 66 69 78 73 75 66 66 69 78 3d 22  ..prefixsuffix="
01e0: 24 7b 70 6b 67 7d 2f 24 7b 6f 73 7d 2d 24 7b 61  ${pkg}/${os}-${a
01f0: 72 63 68 7d 2f 24 7b 76 65 72 73 69 6f 6e 7d 22  rch}/${version}"
0200: 0a 09 70 72 65 66 69 78 3d 22 2f 6f 70 74 2f 61  ..prefix="/opt/a
0210: 70 70 66 73 2f 24 7b 64 6f 6d 61 69 6e 7d 2f 24  ppfs/${domain}/$
0220: 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 0a  {prefixsuffix}".
0230: 09 64 65 73 74 64 69 72 3d 22 24 28 70 77 64 29  .destdir="$(pwd)
0240: 2f 49 4e 53 54 22 0a 0a 09 6d 6b 64 69 72 20 22  /INST"...mkdir "
0250: 24 7b 64 65 73 74 64 69 72 7d 22 20 7c 7c 20 64  ${destdir}" || d
0260: 69 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70  ie.}..function p
0270: 72 65 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a  reconfigure() {.
0280: 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70  .:.}..function p
0290: 6f 73 74 63 6f 6e 66 69 67 75 72 65 28 29 20 7b  ostconfigure() {
02a0: 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20  ..:.}..function 
02b0: 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09 67  configure() {..g
02c0: 6c 69 62 63 76 65 72 73 3d 32 2e 32 30 0a 09 67  libcvers=2.20..g
02d0: 6c 69 62 63 64 69 72 3d 22 2f 6f 70 74 2f 61 70  libcdir="/opt/ap
02e0: 70 66 73 2f 63 6f 72 65 2e 61 70 70 66 73 2e 72  pfs/core.appfs.r
02f0: 6b 65 65 6e 65 2e 6f 72 67 2f 67 6c 69 62 63 2f  keene.org/glibc/
0300: 70 6c 61 74 66 6f 72 6d 2f 24 7b 67 6c 69 62 63  platform/${glibc
0310: 76 65 72 73 7d 22 0a 09 64 79 6e 6c 69 6e 6b 65  vers}"..dynlinke
0320: 72 3d 22 24 28 6c 73 20 22 24 7b 67 6c 69 62 63  r="$(ls "${glibc
0330: 64 69 72 7d 22 2f 6c 69 62 2f 6c 64 2d 6c 69 6e  dir}"/lib/ld-lin
0340: 75 78 2a 2e 73 6f 2e 2a 20 7c 20 74 61 69 6c 20  ux*.so.* | tail 
0350: 2d 6e 20 31 29 22 0a 0a 09 43 46 4c 41 47 53 3d  -n 1)"...CFLAGS=
0360: 22 2d 49 24 7b 67 6c 69 62 63 64 69 72 7d 2f 69  "-I${glibcdir}/i
0370: 6e 63 6c 75 64 65 22 0a 09 43 50 50 46 4c 41 47  nclude"..CPPFLAG
0380: 53 3d 22 2d 49 24 7b 67 6c 69 62 63 64 69 72 7d  S="-I${glibcdir}
0390: 2f 69 6e 63 6c 75 64 65 22 0a 09 4c 44 46 4c 41  /include"..LDFLA
03a0: 47 53 3d 22 2d 57 6c 2c 2d 2d 72 70 61 74 68 2c  GS="-Wl,--rpath,
03b0: 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69 62 20  ${glibcdir}/lib 
03c0: 2d 57 6c 2c 2d 2d 64 79 6e 61 6d 69 63 2d 6c 69  -Wl,--dynamic-li
03d0: 6e 6b 65 72 2c 24 7b 64 79 6e 6c 69 6e 6b 65 72  nker,${dynlinker
03e0: 7d 22 0a 09 65 78 70 6f 72 74 20 43 46 4c 41 47  }"..export CFLAG
03f0: 53 20 43 50 50 46 4c 41 47 53 20 4c 44 46 4c 41  S CPPFLAGS LDFLA
0400: 47 53 0a 0a 09 2e 2f 63 6f 6e 66 69 67 75 72 65  GS..../configure
0410: 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 70 72 65   --prefix="${pre
0420: 66 69 78 7d 22 20 2d 2d 73 79 73 63 6f 6e 66 64  fix}" --sysconfd
0430: 69 72 3d 2f 65 74 63 20 2d 2d 6c 6f 63 61 6c 73  ir=/etc --locals
0440: 74 61 74 65 64 69 72 3d 2f 76 61 72 0a 7d 0a 0a  tatedir=/var.}..
0450: 66 75 6e 63 74 69 6f 6e 20 70 72 65 62 75 69 6c  function prebuil
0460: 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63  d() {..:.}..func
0470: 74 69 6f 6e 20 70 6f 73 74 62 75 69 6c 64 28 29  tion postbuild()
0480: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
0490: 6e 20 62 75 69 6c 64 28 29 20 7b 0a 09 67 72 65  n build() {..gre
04a0: 70 20 22 44 45 53 54 44 49 52 22 20 4d 61 6b 65  p "DESTDIR" Make
04b0: 66 69 6c 65 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  file >/dev/null 
04c0: 7c 7c 20 64 69 65 20 22 44 6f 6e 27 74 20 6b 6e  || die "Don't kn
04d0: 6f 77 20 68 6f 77 20 74 6f 20 62 75 69 6c 64 20  ow how to build 
04e0: 74 68 69 73 20 73 6f 66 74 77 61 72 65 22 0a 0a  this software"..
04f0: 09 6d 61 6b 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f  .make.}..functio
0500: 6e 20 70 72 65 69 6e 73 74 61 6c 6c 28 29 20 7b  n preinstall() {
0510: 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20  ..:.}..function 
0520: 70 6f 73 74 69 6e 73 74 61 6c 6c 28 29 20 7b 0a  postinstall() {.
0530: 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 69  .:.}..function i
0540: 6e 73 74 61 6c 6c 28 29 20 7b 0a 09 6d 61 6b 65  nstall() {..make
0550: 20 69 6e 73 74 61 6c 6c 20 44 45 53 54 44 49 52   install DESTDIR
0560: 3d 22 24 7b 64 65 73 74 64 69 72 7d 22 0a 7d 0a  ="${destdir}".}.
0570: 0a 66 75 6e 63 74 69 6f 6e 20 63 6c 65 61 6e 75  .function cleanu
0580: 70 28 29 20 7b 0a 09 63 64 20 22 24 7b 77 6f 72  p() {..cd "${wor
0590: 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31  kdir}" || exit 1
05a0: 0a 09 63 64 20 2e 2e 20 7c 7c 20 65 78 69 74 20  ..cd .. || exit 
05b0: 31 0a 09 72 6d 20 2d 72 66 20 22 24 7b 77 6f 72  1..rm -rf "${wor
05c0: 6b 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69  kdir}".}..functi
05d0: 6f 6e 20 64 69 65 28 29 20 7b 0a 09 6c 6f 63 61  on die() {..loca
05e0: 6c 20 6d 65 73 73 61 67 65 0a 0a 09 6d 65 73 73  l message...mess
05f0: 61 67 65 3d 22 24 31 22 0a 0a 09 69 66 20 5b 20  age="$1"...if [ 
0600: 2d 6e 20 22 24 7b 6d 65 73 73 61 67 65 7d 22 20  -n "${message}" 
0610: 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22  ]; then...echo "
0620: 65 72 72 6f 72 3a 20 24 7b 6d 65 73 73 61 67 65  error: ${message
0630: 7d 22 20 3e 26 32 0a 09 66 69 0a 0a 09 63 6c 65  }" >&2..fi...cle
0640: 61 6e 75 70 0a 0a 09 65 78 69 74 20 31 0a 7d 0a  anup...exit 1.}.
0650: 0a 73 63 72 69 70 74 64 69 72 3d 22 24 28 63 64  .scriptdir="$(cd
0660: 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24 28 77   "$(dirname "$(w
0670: 68 69 63 68 20 22 24 30 22 29 22 29 22 20 26 26  hich "$0")")" &&
0680: 20 70 77 64 29 22 0a 69 66 20 5b 20 2d 7a 20 22   pwd)".if [ -z "
0690: 24 7b 73 63 72 69 70 74 64 69 72 7d 22 20 5d 3b  ${scriptdir}" ];
06a0: 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 55 6e 61   then..echo "Una
06b0: 62 6c 65 20 74 6f 20 6c 6f 63 61 74 65 20 73 63  ble to locate sc
06c0: 72 69 70 74 20 64 69 72 65 63 74 6f 72 79 22 20  ript directory" 
06d0: 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a  >&2...exit 1.fi.
06e0: 0a 63 64 20 22 24 7b 73 63 72 69 70 74 64 69 72  .cd "${scriptdir
06f0: 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 69 66  }" || exit 1..if
0700: 20 5b 20 2d 66 20 27 62 75 69 6c 64 2e 63 6f 6e   [ -f 'build.con
0710: 66 27 20 5d 3b 20 74 68 65 6e 0a 09 2e 20 27 62  f' ]; then... 'b
0720: 75 69 6c 64 2e 63 6f 6e 66 27 0a 66 69 0a 0a 69  uild.conf'.fi..i
0730: 66 20 5b 20 2d 64 20 22 70 6b 67 73 2f 24 7b 70  f [ -d "pkgs/${p
0740: 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 70 6b  kg}" ]; then..pk
0750: 67 64 69 72 3d 22 70 6b 67 73 2f 24 7b 70 6b 67  gdir="pkgs/${pkg
0760: 7d 22 0a 09 70 6b 67 66 69 6c 65 3d 22 24 7b 70  }"..pkgfile="${p
0770: 6b 67 64 69 72 7d 2f 69 6e 66 6f 22 0a 65 6c 73  kgdir}/info".els
0780: 65 0a 09 70 6b 67 66 69 6c 65 3d 22 70 6b 67 73  e..pkgfile="pkgs
0790: 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b 67 64 69 72  /${pkg}"..pkgdir
07a0: 3d 22 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 66 69  ="${pkgfile}".fi
07b0: 0a 0a 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70  ..if [ ! -e "${p
07c0: 6b 67 66 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e  kgfile}" ]; then
07d0: 0a 09 65 63 68 6f 20 22 49 6e 76 61 6c 69 64 20  ..echo "Invalid 
07e0: 70 61 63 6b 61 67 65 2e 22 20 3e 26 32 0a 0a 09  package." >&2...
07f0: 65 78 69 74 20 31 0a 66 69 0a 0a 70 6b 67 64 61  exit 1.fi..pkgda
0800: 74 65 3d 22 24 28 66 6f 72 20 61 72 74 69 66 61  te="$(for artifa
0810: 63 74 20 69 6e 20 24 28 66 69 6e 64 20 22 24 7b  ct in $(find "${
0820: 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65 20 66  pkgdir}" -type f
0830: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
0840: 20 2d 6e 20 31 20 2d 30 20 66 6f 73 73 69 6c 20   -n 1 -0 fossil 
0850: 66 69 6e 66 6f 20 2d 2d 6c 69 6d 69 74 20 31 20  finfo --limit 1 
0860: 2d 2d 77 69 64 74 68 20 30 20 32 3e 2f 64 65 76  --width 0 2>/dev
0870: 2f 6e 75 6c 6c 20 7c 20 67 72 65 70 20 27 5e 5b  /null | grep '^[
0880: 30 2d 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d 5b 30  0-9][0-9][0-9][0
0890: 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d 2d 5b  -9]-[0-9][0-9]-[
08a0: 30 2d 39 5d 5b 30 2d 39 5d 20 27 20 7c 20 73 65  0-9][0-9] ' | se
08b0: 64 20 27 73 40 5e 5b 5e 20 5d 2a 20 5c 5b 40 40  d 's@^[^ ]* \[@@
08c0: 3b 73 40 5c 5d 2e 2a 40 40 27 20 7c 20 73 6f 72  ;s@\].*@@' | sor
08d0: 74 20 2d 75 29 3b 20 64 6f 20 66 6f 73 73 69 6c  t -u); do fossil
08e0: 20 69 6e 66 6f 20 22 24 7b 61 72 74 69 66 61 63   info "${artifac
08f0: 74 7d 22 20 7c 20 61 77 6b 20 27 2f 5e 75 75 69  t}" | awk '/^uui
0900: 64 3a 2f 7b 20 70 72 69 6e 74 20 24 33 20 24 34  d:/{ print $3 $4
0910: 20 7d 27 20 7c 20 73 65 64 20 27 73 40 5b 2d 3a   }' | sed 's@[-:
0920: 5d 40 40 67 3b 73 40 2e 2e 24 40 5c 2e 26 40 27  ]@@g;s@..$@\.&@'
0930: 3b 20 64 6f 6e 65 20 7c 20 73 6f 72 74 20 2d 6e  ; done | sort -n
0940: 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 69   | tail -n 1)".i
0950: 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67 64 61 74  f [ -z "${pkgdat
0960: 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 70 6b 67  e}" ]; then..pkg
0970: 64 61 74 65 3d 22 24 28 66 69 6e 64 20 22 24 7b  date="$(find "${
0980: 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65 20 66  pkgdir}" -type f
0990: 20 2d 70 72 69 6e 74 66 20 27 25 54 59 25 54 6d   -printf '%TY%Tm
09a0: 25 54 64 25 54 48 25 54 4d 2e 25 54 53 5c 6e 27  %Td%TH%TM.%TS\n'
09b0: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 20 63   2>/dev/null | c
09c0: 75 74 20 2d 66 20 31 2d 32 20 2d 64 20 27 2e 27  ut -f 1-2 -d '.'
09d0: 20 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74 61 69   | sort -n | tai
09e0: 6c 20 2d 6e 20 31 29 22 0a 66 69 0a 0a 2e 20 22  l -n 1)".fi... "
09f0: 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 0a 61 72 63  ${pkgfile}"..arc
0a00: 68 69 76 65 64 69 72 3d 22 24 28 70 77 64 29 2f  hivedir="$(pwd)/
0a10: 41 52 43 48 49 56 45 22 0a 77 6f 72 6b 64 69 72  ARCHIVE".workdir
0a20: 3d 22 77 6f 72 6b 64 69 72 2d 24 24 24 7b 52 41  ="workdir-$$${RA
0a30: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  NDOM}${RANDOM}${
0a40: 52 41 4e 44 4f 4d 7d 22 0a 73 72 63 66 69 6c 65  RANDOM}".srcfile
0a50: 3d 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d 2f  ="${archivedir}/
0a60: 24 7b 70 6b 67 7d 22 0a 6d 6b 64 69 72 20 22 24  ${pkg}".mkdir "$
0a70: 7b 61 72 63 68 69 76 65 64 69 72 7d 22 20 3e 2f  {archivedir}" >/
0a80: 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f  dev/null 2>/dev/
0a90: 6e 75 6c 6c 0a 6d 6b 64 69 72 20 22 24 7b 77 6f  null.mkdir "${wo
0aa0: 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20  rkdir}" || exit 
0ab0: 31 0a 63 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d  1.cd "${workdir}
0ac0: 22 20 7c 7c 20 65 78 69 74 20 31 0a 77 6f 72 6b  " || exit 1.work
0ad0: 64 69 72 3d 22 24 28 70 77 64 29 22 0a 0a 69 66  dir="$(pwd)"..if
0ae0: 20 5b 20 21 20 2d 65 20 22 24 7b 73 72 63 66 69   [ ! -e "${srcfi
0af0: 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 23 20  le}" ]; then..# 
0b00: 44 6f 77 6e 6c 6f 61 64 0a 09 23 23 20 43 6c 65  Download..## Cle
0b10: 61 6e 75 70 0a 09 72 6d 20 2d 66 20 73 72 63 2e  anup..rm -f src.
0b20: 6e 65 77 20 73 72 63 0a 0a 09 23 23 20 46 65 74  new src...## Fet
0b30: 63 68 20 66 69 6c 65 0a 09 77 67 65 74 20 2d 4f  ch file..wget -O
0b40: 20 73 72 63 2e 6e 65 77 20 22 24 7b 75 72 6c 7d   src.new "${url}
0b50: 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 23 23  " || exit 1...##
0b60: 20 56 65 72 69 66 79 20 73 69 67 6e 61 74 75 72   Verify signatur
0b70: 65 0a 09 73 72 63 5f 73 68 61 32 35 36 3d 22 24  e..src_sha256="$
0b80: 28 6f 70 65 6e 73 73 6c 20 73 68 61 32 35 36 20  (openssl sha256 
0b90: 27 73 72 63 2e 6e 65 77 27 20 7c 20 73 65 64 20  'src.new' | sed 
0ba0: 27 73 40 5e 2e 2a 3d 20 40 40 27 29 22 0a 09 69  's@^.*= @@')"..i
0bb0: 66 20 5b 20 22 24 7b 73 72 63 5f 73 68 61 32 35  f [ "${src_sha25
0bc0: 36 7d 22 20 21 3d 20 22 24 7b 73 68 61 32 35 36  6}" != "${sha256
0bd0: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68  }" ]; then...ech
0be0: 6f 20 22 53 48 41 32 35 36 20 6d 69 73 6d 61 74  o "SHA256 mismat
0bf0: 63 68 3a 20 20 44 6f 77 6e 6c 6f 61 64 65 64 3a  ch:  Downloaded:
0c00: 20 24 7b 73 72 63 5f 73 68 61 32 35 36 7d 20 21   ${src_sha256} !
0c10: 3d 20 45 78 70 65 63 74 65 64 3a 20 24 7b 73 68  = Expected: ${sh
0c20: 61 32 35 36 7d 22 20 3e 26 32 0a 0a 09 09 65 78  a256}" >&2....ex
0c30: 69 74 20 31 0a 09 66 69 0a 0a 09 23 23 20 4d 6f  it 1..fi...## Mo
0c40: 76 65 20 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61  ve file into pla
0c50: 63 65 0a 09 6d 76 20 73 72 63 2e 6e 65 77 20 22  ce..mv src.new "
0c60: 24 7b 61 72 63 68 69 76 65 64 69 72 7d 2f 24 7b  ${archivedir}/${
0c70: 70 6b 67 7d 22 0a 66 69 0a 0a 23 20 44 65 63 6f  pkg}".fi..# Deco
0c80: 6d 70 72 65 73 73 20 61 72 63 68 69 76 65 0a 23  mpress archive.#
0c90: 23 20 44 65 74 65 72 6d 69 6e 65 20 74 79 70 65  # Determine type
0ca0: 20 6f 66 20 61 72 63 68 69 76 65 0a 63 61 73 65   of archive.case
0cb0: 20 22 24 7b 75 72 6c 7d 22 20 69 6e 0a 09 2a 2e   "${url}" in..*.
0cc0: 74 61 72 2e 78 7a 7c 2a 2e 74 61 72 2e 78 7a 27  tar.xz|*.tar.xz'
0cd0: 3f 27 2a 7c 2a 2e 74 78 7a 29 0a 09 09 64 65 63  ?'*|*.txz)...dec
0ce0: 6f 6d 70 72 65 73 73 3d 27 78 7a 27 0a 09 09 3b  ompress='xz'...;
0cf0: 3b 0a 09 2a 2e 74 61 72 2e 67 7a 7c 2a 2e 74 61  ;..*.tar.gz|*.ta
0d00: 72 2e 67 7a 27 3f 27 2a 7c 2a 2e 74 67 7a 29 0a  r.gz'?'*|*.tgz).
0d10: 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27 67 7a  ..decompress='gz
0d20: 69 70 27 0a 09 09 3b 3b 0a 09 2a 2e 74 61 72 2e  ip'...;;..*.tar.
0d30: 62 7a 32 7c 2a 2e 74 61 72 2e 62 7a 32 27 3f 27  bz2|*.tar.bz2'?'
0d40: 2a 7c 2a 2e 74 62 7a 32 29 0a 09 09 64 65 63 6f  *|*.tbz2)...deco
0d50: 6d 70 72 65 73 73 3d 27 62 7a 69 70 32 27 0a 09  mpress='bzip2'..
0d60: 09 3b 3b 0a 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70  .;;..*.zip|*.zip
0d70: 27 3f 27 2a 29 0a 09 09 64 65 63 6f 6d 70 72 65  '?'*)...decompre
0d80: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 3b 3b 0a  ss='unzip'...;;.
0d90: 09 2a 29 0a 09 09 65 63 68 6f 20 22 55 6e 6b 6e  .*)...echo "Unkn
0da0: 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69 6f 6e 20  own compression 
0db0: 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c 7d 22 20  method: ${url}" 
0dc0: 3e 26 32 0a 0a 09 09 65 78 69 74 20 31 0a 09 09  >&2....exit 1...
0dd0: 3b 3b 0a 65 73 61 63 0a 0a 23 23 20 44 6f 20 64  ;;.esac..## Do d
0de0: 65 63 6f 6d 70 72 65 73 73 69 6f 6e 0a 63 61 73  ecompression.cas
0df0: 65 20 22 24 7b 64 65 63 6f 6d 70 72 65 73 73 7d  e "${decompress}
0e00: 22 20 69 6e 0a 09 75 6e 7a 69 70 29 0a 09 09 75  " in..unzip)...u
0e10: 6e 7a 69 70 20 22 24 7b 73 72 63 66 69 6c 65 7d  nzip "${srcfile}
0e20: 22 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c 65  " || die 'Unable
0e30: 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20 61   to uncompress a
0e40: 72 63 68 69 76 65 27 0a 09 09 3b 3b 0a 09 2a 29  rchive'...;;..*)
0e50: 0a 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0e60: 7d 22 20 2d 64 63 20 22 24 7b 73 72 63 66 69 6c  }" -dc "${srcfil
0e70: 65 7d 22 20 7c 20 74 61 72 20 2d 78 66 20 2d 20  e}" | tar -xf - 
0e80: 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74  || die 'Unable t
0e90: 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63  o uncompress arc
0ea0: 68 69 76 65 27 0a 09 09 3b 3b 0a 65 73 61 63 0a  hive'...;;.esac.
0eb0: 0a 23 23 20 43 6c 65 61 6e 75 70 20 73 6f 75 72  .## Cleanup sour
0ec0: 63 65 0a 72 6d 20 2d 66 20 73 72 63 0a 0a 23 20  ce.rm -f src..# 
0ed0: 49 66 20 77 65 20 6a 75 73 74 20 68 61 76 65 20  If we just have 
0ee0: 6f 6e 65 20 64 69 72 65 63 74 6f 72 79 2c 20 75  one directory, u
0ef0: 73 65 20 74 68 61 74 20 64 69 72 65 63 74 6f 72  se that director
0f00: 79 0a 64 69 72 3d 22 24 28 65 63 68 6f 20 2a 29  y.dir="$(echo *)
0f10: 22 0a 69 66 20 5b 20 2d 65 20 22 24 7b 64 69 72  ".if [ -e "${dir
0f20: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 76 20 22  }" ]; then..mv "
0f30: 24 7b 64 69 72 7d 22 2f 2a 20 2e 0a 66 69 0a 0a  ${dir}"/* ..fi..
0f40: 23 20 53 74 61 72 74 20 6c 6f 67 67 69 6e 67 0a  # Start logging.
0f50: 73 65 74 20 2d 78 0a 0a 23 20 44 65 74 65 72 6d  set -x..# Determ
0f60: 69 6e 65 20 70 72 6f 70 65 72 74 69 65 73 0a 64  ine properties.d
0f70: 65 74 65 72 6d 69 6e 65 50 72 65 66 69 78 0a 0a  eterminePrefix..
0f80: 23 20 53 74 61 72 74 20 74 68 65 20 62 75 69 6c  # Start the buil
0f90: 64 0a 70 72 65 63 6f 6e 66 69 67 75 72 65 20 7c  d.preconfigure |
0fa0: 7c 20 64 69 65 20 27 70 72 65 63 6f 6e 66 69 67  | die 'preconfig
0fb0: 75 72 65 20 66 61 69 6c 65 64 27 0a 63 6f 6e 66  ure failed'.conf
0fc0: 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27 63 6f  igure || die 'co
0fd0: 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a  nfigure failed'.
0fe0: 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 20 7c 7c  postconfigure ||
0ff0: 20 64 69 65 20 27 70 6f 73 74 63 6f 6e 66 69 67   die 'postconfig
1000: 75 72 65 20 66 61 69 6c 65 64 27 0a 0a 70 72 65  ure failed'..pre
1010: 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 72  build || die 'pr
1020: 65 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 62  ebuild failed'.b
1030: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 62 75 69  uild || die 'bui
1040: 6c 64 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 62  ld failed'.postb
1050: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 6f 73  uild || die 'pos
1060: 74 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 0a  tbuild failed'..
1070: 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  preinstall || di
1080: 65 20 27 70 72 65 69 6e 73 74 61 6c 6c 20 66 61  e 'preinstall fa
1090: 69 6c 65 64 27 0a 69 6e 73 74 61 6c 6c 20 7c 7c  iled'.install ||
10a0: 20 64 69 65 20 27 69 6e 73 74 61 6c 6c 20 66 61   die 'install fa
10b0: 69 6c 65 64 27 0a 70 6f 73 74 69 6e 73 74 61 6c  iled'.postinstal
10c0: 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 69 6e  l || die 'postin
10d0: 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 0a 28  stall failed'..(
10e0: 0a 09 63 61 73 65 20 22 24 7b 74 61 72 67 65 74  ..case "${target
10f0: 6d 6f 64 65 7d 22 20 69 6e 0a 09 09 69 6e 73 74  mode}" in...inst
1100: 61 6c 6c 29 0a 09 09 09 61 70 70 64 69 72 3d 22  all)....appdir="
1110: 24 28 61 70 70 66 73 69 6e 73 74 61 6c 6c 64 69  $(appfsinstalldi
1120: 72 29 2f 24 7b 70 72 65 66 69 78 73 75 66 66 69  r)/${prefixsuffi
1130: 78 7d 22 0a 09 09 09 6d 6b 64 69 72 20 2d 70 20  x}"....mkdir -p 
1140: 22 24 7b 61 70 70 64 69 72 7d 22 0a 0a 09 09 09  "${appdir}".....
1150: 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d 2f 24  cd "${destdir}/$
1160: 7b 70 72 65 66 69 78 7d 22 20 7c 7c 20 65 78 69  {prefix}" || exi
1170: 74 20 31 0a 0a 09 09 09 63 70 20 2d 72 70 20 2a  t 1.....cp -rp *
1180: 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 09 09 09   "${appdir}"....
1190: 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22  find "${appdir}"
11a0: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
11b0: 20 2d 30 20 74 6f 75 63 68 20 2d 74 20 22 24 7b   -0 touch -t "${
11c0: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e  pkgdate}"....fin
11d0: 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70  d "${appdir}" -p
11e0: 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30  rint0 | xargs -0
11f0: 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b   touch -m -t "${
1200: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e  pkgdate}"....fin
1210: 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70  d "${appdir}" -p
1220: 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30  rint0 | xargs -0
1230: 20 74 6f 75 63 68 20 2d 61 20 2d 74 20 22 24 7b   touch -a -t "${
1240: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 3b 3b 0a  pkgdate}"....;;.
1250: 09 09 61 72 63 68 69 76 65 29 0a 09 09 09 61 72  ..archive)....ar
1260: 63 68 69 76 65 66 69 6c 65 3d 22 24 7b 73 63 72  chivefile="${scr
1270: 69 70 74 64 69 72 7d 2f 24 7b 70 6b 67 7d 2d 24  iptdir}/${pkg}-$
1280: 7b 76 65 72 73 69 6f 6e 7d 2d 24 28 65 63 68 6f  {version}-$(echo
1290: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 20 7c 20   "${pkgdate}" | 
12a0: 73 65 64 20 27 73 40 5c 2e 40 40 67 27 29 2d 24  sed 's@\.@@g')-$
12b0: 7b 64 6f 6d 61 69 6e 7d 2e 63 70 69 6f 22 0a 09  {domain}.cpio"..
12c0: 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d  ..cd "${destdir}
12d0: 2f 24 7b 70 72 65 66 69 78 7d 2f 2e 2e 2f 2e 2e  /${prefix}/../..
12e0: 2f 2e 2e 22 20 7c 7c 20 65 78 69 74 20 31 0a 09  /.." || exit 1..
12f0: 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78  ..find "${prefix
1300: 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e 74 30  suffix}" -print0
1310: 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63   | xargs -0 touc
1320: 68 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65 7d  h -t "${pkgdate}
1330: 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65  "....find "${pre
1340: 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72 69  fixsuffix}" -pri
1350: 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74  nt0 | xargs -0 t
1360: 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70 6b  ouch -m -t "${pk
1370: 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20  gdate}"....find 
1380: 22 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d  "${prefixsuffix}
1390: 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67  " -print0 | xarg
13a0: 73 20 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74  s -0 touch -a -t
13b0: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09   "${pkgdate}"...
13c0: 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73  .find "${prefixs
13d0: 75 66 66 69 78 7d 22 20 7c 20 73 6f 72 74 20 7c  uffix}" | sort |
13e0: 20 63 70 69 6f 20 2d 2d 6f 77 6e 65 72 20 30 3a   cpio --owner 0:
13f0: 30 20 2d 48 20 6e 65 77 63 20 2d 6f 20 3e 20 22  0 -H newc -o > "
1400: 24 7b 61 72 63 68 69 76 65 66 69 6c 65 7d 22 0a  ${archivefile}".
1410: 09 09 09 3b 3b 0a 09 65 73 61 63 0a 29 20 7c 7c  ...;;..esac.) ||
1420: 20 64 69 65 20 27 66 69 6e 61 6c 20 69 6e 73 74   die 'final inst
1430: 61 6c 6c 61 74 69 6f 6e 20 66 61 69 6c 65 64 27  allation failed'
1440: 0a 0a 63 6c 65 61 6e 75 70 0a 0a 65 78 69 74 20  ..cleanup..exit 
1450: 30 0a                                            0.